/* A Bison parser, made by GNU Bison 2.0.  */

/* Skeleton parser for Yacc-like parsing with Bison,
   Copyright (C) 1984, 1989, 1990, 2000, 2001, 2002, 2003, 2004 Free Software Foundation, Inc.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place - Suite 330,
   Boston, MA 02111-1307, USA.  */

/* As a special exception, when this file is copied by Bison into a
   Bison output file, you may use that output file without restriction.
   This special exception was added by the Free Software Foundation
   in version 1.24 of Bison.  */

/* Written by Richard Stallman by simplifying the original so called
   ``semantic'' parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Using locations.  */
#define YYLSP_NEEDED 0



/* Tokens.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
   /* Put the tokens into the symbol table, so that GDB and other debuggers
      know about them.  */
   enum yytokentype {
     TCOMMENT = 258,
     TASSERT = 259,
     TBY = 260,
     TCEILING = 261,
     TCOLON = 262,
     TCOMMA = 263,
     TCONST = 264,
     TDO = 265,
     TDOANY = 266,
     TELSE = 267,
     TENDFOR = 268,
     TENDIF = 269,
     TEQ = 270,
     TEQUAL = 271,
     TEXP = 272,
     TFLOAT = 273,
     TFLOOR = 274,
     TFOR = 275,
     TGE = 276,
     TGT = 277,
     TRAND = 278,
     TID = 279,
     TIF = 280,
     TINT = 281,
     TINTEGER = 282,
     TLE = 283,
     TLT = 284,
     TLP = 285,
     TMAX = 286,
     TMIN = 287,
     TMINUS = 288,
     TMOD = 289,
     TNE = 290,
     TAND = 291,
     TOR = 292,
     TNOT = 293,
     TPARFOR = 294,
     TPLUS = 295,
     TREAL = 296,
     TRP = 297,
     TSEMI = 298,
     TSLASH = 299,
     TSQRT = 300,
     TSTAR = 301,
     TTHEN = 302,
     TTO = 303,
     TVECFOR = 304,
     TLCB = 305,
     TRCB = 306,
     TFORMAL = 307,
     TCOMMON = 308,
     TSTATIC = 309,
     TAUTO = 310,
     TPRIVATE = 311,
     TBUILTIN = 312,
     TIN = 313,
     TOUT = 314,
     TINOUT = 315,
     TRETURN = 316,
     TPLUSEQUAL = 317,
     TSTAREQUAL = 318,
     TMAXEQUAL = 319,
     TMINEQUAL = 320
   };
#endif
#define TCOMMENT 258
#define TASSERT 259
#define TBY 260
#define TCEILING 261
#define TCOLON 262
#define TCOMMA 263
#define TCONST 264
#define TDO 265
#define TDOANY 266
#define TELSE 267
#define TENDFOR 268
#define TENDIF 269
#define TEQ 270
#define TEQUAL 271
#define TEXP 272
#define TFLOAT 273
#define TFLOOR 274
#define TFOR 275
#define TGE 276
#define TGT 277
#define TRAND 278
#define TID 279
#define TIF 280
#define TINT 281
#define TINTEGER 282
#define TLE 283
#define TLT 284
#define TLP 285
#define TMAX 286
#define TMIN 287
#define TMINUS 288
#define TMOD 289
#define TNE 290
#define TAND 291
#define TOR 292
#define TNOT 293
#define TPARFOR 294
#define TPLUS 295
#define TREAL 296
#define TRP 297
#define TSEMI 298
#define TSLASH 299
#define TSQRT 300
#define TSTAR 301
#define TTHEN 302
#define TTO 303
#define TVECFOR 304
#define TLCB 305
#define TRCB 306
#define TFORMAL 307
#define TCOMMON 308
#define TSTATIC 309
#define TAUTO 310
#define TPRIVATE 311
#define TBUILTIN 312
#define TIN 313
#define TOUT 314
#define TINOUT 315
#define TRETURN 316
#define TPLUSEQUAL 317
#define TSTAREQUAL 318
#define TMAXEQUAL 319
#define TMINEQUAL 320




/* Copy the first part of user declarations.  */
#line 4 "../../../../../git/pers/barvinok/omega/petit/src/petity.y"

#include <string.h>
#include <stdlib.h>
#include <basic/assert.h>
#include <basic/Exit.h>
#include <petit/lang-interf.h>
#include <petit/make.h>
#include <petit/tree.h>
#include <petit/vutil.h>
#include <petit/petity.h>
#ifdef WIN32
#include <io.h>
#define isatty _isatty
#include <malloc.h>
#define alloca _alloca
#endif

#define AllowComments 1

namespace omega {

static void parse_die();
static int parse_intval();
static void parse_linknode( node *new_node );
static void parse_unlinknode();
static void parse_linknodeto( node *old, node *new_node );
static void parse_pushscope( node *n );
static void parse_popscope();
static node *parse_binaryop( node *left, optype op, node *right );
static void parse_forloop(optype op, symtabentry *index,
			       node *lower, node *upper, node *inc);
static void parse_endforloop();

static void parse_stmt_index( node *n );
static void parse_check_stmt_number();
static void parse_init();
static void yyerror( char *s);
symtabentry *add_symbol(const char *name, int new_int,
			symboltype symtype, exprtype exptype,
			nametabentry *onam);
static void CheckEnd();
static symtabentry *parse_doid_symbol();

/* global variables: */
/* line number */
unsigned long int Lines;

/* Entry node */
node *Entry;

/* Exit node */
node *ExitNode;

/* List of assertions */
node *Assertions = NULL;

/* Current head of name table */
nametabentry *NameHead;

/* communication from lexer */
/* name of ID */
char P_IDname[MAXIDLENGTH], P_INTname[MAXIDLENGTH];

/* line number of next token */
unsigned long int P_Lines;
} // end of namespace omega

#ifdef WIN32
#include <io.h>
#define isatty _isatty
#endif
#include "petit/petitl.c"

namespace omega {
/* current nest level in loops */
unsigned long int P_LoopNest;

#include <petit/ddutil.h>
char *loopsyms[maxnest];

/* current statement number */
unsigned long int P_StmtNumber;

/* A node pointer */
node *P_Node;

/* A symbol table entry pointer */
symtabentry *P_Sym, *P_Sym1, *P_DeclSym;

/* type of symbol being declared */
symboltype P_SaveType;

var_class SaveClass;

/* What to use for 'prev' of next node, 'parent' of next node */
node *P_NextPrev, *P_NextParent;

/* To allow undeclared variables appear in array bounds */
int NoNewOldCheck = 0;

/* to prohibit RETURN statements from appearing not at the end */
int ShouldBeEnd;

} // end of namespace omega

using namespace omega;

/* end of declarations section */


/* Enabling traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

#if ! defined (YYSTYPE) && ! defined (YYSTYPE_IS_DECLARED)
#line 114 "../../../../../git/pers/barvinok/omega/petit/src/petity.y"
typedef union YYSTYPE {
    int iv;
    node *np;
    symtabentry *stp;
    optype op;
    } YYSTYPE;
/* Line 190 of yacc.c.  */
#line 323 "petity.cc"
# define yystype YYSTYPE /* obsolescent; will be withdrawn */
# define YYSTYPE_IS_DECLARED 1
# define YYSTYPE_IS_TRIVIAL 1
#endif



/* Copy the second part of user declarations.  */


/* Line 213 of yacc.c.  */
#line 335 "petity.cc"

#if ! defined (yyoverflow) || YYERROR_VERBOSE

# ifndef YYFREE
#  define YYFREE free
# endif
# ifndef YYMALLOC
#  define YYMALLOC malloc
# endif

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   else
#    define YYSTACK_ALLOC alloca
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's `empty if-body' warning. */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
# else
#  if defined (__STDC__) || defined (__cplusplus)
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   define YYSIZE_T size_t
#  endif
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
# endif
#endif /* ! defined (yyoverflow) || YYERROR_VERBOSE */


#if (! defined (yyoverflow) \
     && (! defined (__cplusplus) \
	 || (defined (YYSTYPE_IS_TRIVIAL) && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  short int yyss;
  YYSTYPE yyvs;
  };

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (short int) + sizeof (YYSTYPE))			\
      + YYSTACK_GAP_MAXIMUM)

/* Copy COUNT objects from FROM to TO.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined (__GNUC__) && 1 < __GNUC__
#   define YYCOPY(To, From, Count) \
      __builtin_memcpy (To, From, (Count) * sizeof (*(From)))
#  else
#   define YYCOPY(To, From, Count)		\
      do					\
	{					\
	  register YYSIZE_T yyi;		\
	  for (yyi = 0; yyi < (Count); yyi++)	\
	    (To)[yyi] = (From)[yyi];		\
	}					\
      while (0)
#  endif
# endif

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack)					\
    do									\
      {									\
	YYSIZE_T yynewbytes;						\
	YYCOPY (&yyptr->Stack, Stack, yysize);				\
	Stack = &yyptr->Stack;						\
	yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
	yyptr += yynewbytes / sizeof (*yyptr);				\
      }									\
    while (0)

#endif

#if defined (__STDC__) || defined (__cplusplus)
   typedef signed char yysigned_char;
#else
   typedef short int yysigned_char;
#endif

/* YYFINAL -- State number of the termination state. */
#define YYFINAL  3
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   532

/* YYNTOKENS -- Number of terminals. */
#define YYNTOKENS  66
/* YYNNTS -- Number of nonterminals. */
#define YYNNTS  58
/* YYNRULES -- Number of rules. */
#define YYNRULES  140
/* YYNRULES -- Number of states. */
#define YYNSTATES  264

/* YYTRANSLATE(YYLEX) -- Bison symbol number corresponding to YYLEX.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   320

#define YYTRANSLATE(YYX) 						\
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[YYLEX] -- Bison symbol number corresponding to YYLEX.  */
static const unsigned char yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65
};

#if YYDEBUG
/* YYPRHS[YYN] -- Index of the first RHS symbol of rule number YYN in
   YYRHS.  */
static const unsigned short int yyprhs[] =
{
       0,     0,     3,     4,     7,     9,    13,    14,    16,    18,
      20,    22,    24,    26,    28,    30,    32,    34,    36,    38,
      40,    43,    48,    50,    54,    58,    60,    62,    64,    66,
      68,    69,    75,    78,    80,    84,    88,    89,   100,   101,
     113,   114,   126,   127,   130,   131,   143,   144,   156,   157,
     169,   171,   173,   175,   177,   179,   181,   182,   190,   191,
     195,   196,   197,   202,   203,   205,   207,   209,   211,   213,
     215,   217,   219,   221,   223,   225,   227,   231,   232,   236,
     237,   238,   239,   240,   250,   251,   254,   259,   261,   265,
     267,   268,   270,   274,   276,   280,   282,   284,   286,   288,
     292,   296,   299,   302,   306,   310,   312,   314,   315,   321,
     323,   325,   329,   333,   337,   340,   343,   347,   351,   355,
     359,   363,   367,   371,   375,   379,   383,   387,   390,   394,
     398,   402,   407,   411,   418,   425,   426,   432,   434,   436,
     438
};

/* YYRHS -- A `-1'-separated list of the rules' RHS. */
static const yysigned_char yyrhs[] =
{
      67,     0,    -1,    -1,    68,    69,    -1,    70,    -1,    69,
      43,    70,    -1,    -1,    72,    -1,    73,    -1,    74,    -1,
      75,    -1,    79,    -1,    82,    -1,    87,    -1,    95,    -1,
      89,    -1,    91,    -1,    99,    -1,    71,    -1,    61,    -1,
      61,   119,    -1,     4,    30,   119,    42,    -1,     3,    -1,
      77,    16,   119,    -1,    77,    76,   119,    -1,    62,    -1,
      63,    -1,    64,    -1,    65,    -1,    24,    -1,    -1,    24,
      78,    30,   123,    42,    -1,     9,    80,    -1,    81,    -1,
      80,     8,    81,    -1,   115,    16,   117,    -1,    -1,    10,
     116,    16,   119,    93,   119,    86,    43,    83,    70,    -1,
      -1,    10,   116,    16,   119,    93,   119,    86,    84,    50,
      69,    51,    -1,    -1,    20,   116,    16,   119,    93,   119,
      86,    85,    10,    69,    13,    -1,    -1,    94,   119,    -1,
      -1,    49,   116,    16,   119,    93,   119,    86,    88,    10,
      69,    13,    -1,    -1,    39,   116,    16,   119,    93,   119,
      86,    90,    10,    69,    13,    -1,    -1,    11,   116,    16,
     119,    93,   119,    86,    92,    10,    69,    13,    -1,    48,
      -1,     8,    -1,     7,    -1,     5,    -1,     8,    -1,     7,
      -1,    -1,    25,   119,    96,    47,    69,    97,    14,    -1,
      -1,    12,    98,    69,    -1,    -1,    -1,   101,   102,   100,
     103,    -1,    -1,    55,    -1,    53,    -1,    54,    -1,    52,
      -1,    58,    -1,    59,    -1,    60,    -1,    56,    -1,    57,
      -1,    27,    -1,    41,    -1,   104,    -1,   103,     8,   104,
      -1,    -1,   115,   105,   110,    -1,    -1,    -1,    -1,    -1,
     115,   106,    30,   107,   113,   108,    42,   109,   110,    -1,
      -1,    16,   112,    -1,    16,    50,   111,    51,    -1,   112,
      -1,   111,     8,   112,    -1,   119,    -1,    -1,   114,    -1,
     113,     8,   114,    -1,   119,    -1,   119,     7,   119,    -1,
      24,    -1,    24,    -1,    24,    -1,    26,    -1,   117,    40,
     117,    -1,   117,    33,   117,    -1,    33,   117,    -1,    40,
     117,    -1,   117,    46,   117,    -1,    30,   117,    42,    -1,
      24,    -1,   118,    -1,    -1,   118,   120,    30,   123,    42,
      -1,    26,    -1,    18,    -1,    30,   119,    42,    -1,   119,
      40,   119,    -1,   119,    33,   119,    -1,    40,   119,    -1,
      33,   119,    -1,   119,    46,   119,    -1,   119,    44,   119,
      -1,   119,    17,   119,    -1,   119,    29,   119,    -1,   119,
      28,   119,    -1,   119,    15,   119,    -1,   119,    35,   119,
      -1,   119,    21,   119,    -1,   119,    22,   119,    -1,   119,
      36,   119,    -1,   119,    37,   119,    -1,    38,   119,    -1,
     119,    34,   119,    -1,   119,    31,   119,    -1,   119,    32,
     119,    -1,    45,    30,   119,    42,    -1,    23,    30,    42,
      -1,    19,    30,   119,    44,   119,    42,    -1,     6,    30,
     119,    44,   119,    42,    -1,    -1,   122,   121,    30,   123,
      42,    -1,    31,    -1,    32,    -1,   119,    -1,   123,     8,
     119,    -1
};

/* YYRLINE[YYN] -- source line where rule number YYN was defined.  */
static const unsigned short int yyrline[] =
{
       0,   170,   170,   170,   184,   186,   189,   190,   191,   192,
     193,   194,   195,   196,   197,   198,   199,   200,   201,   204,
     205,   208,   221,   237,   260,   288,   289,   290,   291,   296,
     324,   323,   371,   375,   377,   381,   398,   397,   403,   402,
     408,   407,   414,   415,   421,   420,   432,   431,   443,   442,
     453,   455,   457,   461,   463,   465,   470,   469,   493,   492,
     499,   502,   502,   505,   506,   507,   508,   509,   510,   511,
     512,   513,   514,   517,   518,   523,   525,   530,   529,   556,
     567,   567,   568,   555,   595,   596,   597,   600,   601,   603,
     608,   609,   610,   614,   629,   645,   650,   655,   666,   669,
     672,   675,   678,   681,   684,   689,   694,   712,   711,   752,
     760,   769,   772,   775,   778,   781,   784,   787,   790,   793,
     796,   799,   802,   805,   808,   811,   814,   817,   820,   823,
     826,   829,   832,   837,   842,   848,   847,   870,   873,   878,
     881
};
#endif

#if YYDEBUG || YYERROR_VERBOSE
/* YYTNME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals. */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "TCOMMENT", "TASSERT", "TBY", "TCEILING",
  "TCOLON", "TCOMMA", "TCONST", "TDO", "TDOANY", "TELSE", "TENDFOR",
  "TENDIF", "TEQ", "TEQUAL", "TEXP", "TFLOAT", "TFLOOR", "TFOR", "TGE",
  "TGT", "TRAND", "TID", "TIF", "TINT", "TINTEGER", "TLE", "TLT", "TLP",
  "TMAX", "TMIN", "TMINUS", "TMOD", "TNE", "TAND", "TOR", "TNOT",
  "TPARFOR", "TPLUS", "TREAL", "TRP", "TSEMI", "TSLASH", "TSQRT", "TSTAR",
  "TTHEN", "TTO", "TVECFOR", "TLCB", "TRCB", "TFORMAL", "TCOMMON",
  "TSTATIC", "TAUTO", "TPRIVATE", "TBUILTIN", "TIN", "TOUT", "TINOUT",
  "TRETURN", "TPLUSEQUAL", "TSTAREQUAL", "TMAXEQUAL", "TMINEQUAL",
  "$accept", "pgm", "@1", "stlist", "stmt", "streturn", "stassert",
  "stcomment", "stasgn", "stasgnoper", "asgnoper", "lhs", "@2", "stconst",
  "constlist", "constdecl", "stfor", "@3", "@4", "@5", "optforby",
  "stforall", "@6", "stparfor", "@7", "stdoany", "@8", "forto", "forby",
  "stif", "@9", "elsepart", "@10", "stdecl", "@11", "class", "type",
  "decllist", "decl", "@12", "@13", "@14", "@15", "@16", "init",
  "initlist", "init1", "boundlist", "bound", "newid", "doid", "cexpr",
  "oldid", "expr", "@17", "@18", "assocop", "list", 0
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[YYLEX-NUM] -- Internal token number corresponding to
   token YYLEX-NUM.  */
static const unsigned short int yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320
};
# endif

/* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const unsigned char yyr1[] =
{
       0,    66,    68,    67,    69,    69,    70,    70,    70,    70,
      70,    70,    70,    70,    70,    70,    70,    70,    70,    71,
      71,    72,    73,    74,    75,    76,    76,    76,    76,    77,
      78,    77,    79,    80,    80,    81,    83,    82,    84,    82,
      85,    82,    86,    86,    88,    87,    90,    89,    92,    91,
      93,    93,    93,    94,    94,    94,    96,    95,    98,    97,
      97,   100,    99,   101,   101,   101,   101,   101,   101,   101,
     101,   101,   101,   102,   102,   103,   103,   105,   104,   106,
     107,   108,   109,   104,   110,   110,   110,   111,   111,   112,
     113,   113,   113,   114,   114,   115,   116,   117,   117,   117,
     117,   117,   117,   117,   117,   118,   119,   120,   119,   119,
     119,   119,   119,   119,   119,   119,   119,   119,   119,   119,
     119,   119,   119,   119,   119,   119,   119,   119,   119,   119,
     119,   119,   119,   119,   119,   121,   119,   122,   122,   123,
     123
};

/* YYR2[YYN] -- Number of symbols composing right hand side of rule YYN.  */
static const unsigned char yyr2[] =
{
       0,     2,     0,     2,     1,     3,     0,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       2,     4,     1,     3,     3,     1,     1,     1,     1,     1,
       0,     5,     2,     1,     3,     3,     0,    10,     0,    11,
       0,    11,     0,     2,     0,    11,     0,    11,     0,    11,
       1,     1,     1,     1,     1,     1,     0,     7,     0,     3,
       0,     0,     4,     0,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     3,     0,     3,     0,
       0,     0,     0,     9,     0,     2,     4,     1,     3,     1,
       0,     1,     3,     1,     3,     1,     1,     1,     1,     3,
       3,     2,     2,     3,     3,     1,     1,     0,     5,     1,
       1,     3,     3,     3,     2,     2,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     2,     3,     3,
       3,     4,     3,     6,     6,     0,     5,     1,     1,     1,
       3
};

/* YYDEFACT[STATE-NAME] -- Default rule to reduce with in state
   STATE-NUM when YYTABLE doesn't specify something else to do.  Zero
   means the default is an error.  */
static const unsigned char yydefact[] =
{
       2,     0,     6,     1,    22,     0,     0,     0,     0,     0,
      29,     0,     0,     0,    67,    65,    66,    64,    71,    72,
      68,    69,    70,    19,     3,     4,    18,     7,     8,     9,
      10,     0,    11,    12,    13,    15,    16,    14,    17,     0,
       0,    95,    32,    33,     0,    96,     0,     0,     0,     0,
       0,   110,     0,     0,   105,   109,     0,   137,   138,     0,
       0,     0,     0,   106,    56,   135,     0,     0,    20,     6,
       0,    25,    26,    27,    28,     0,    73,    74,    61,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     115,   127,   114,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     5,    23,    24,     0,    21,
      34,    97,    98,     0,     0,     0,    35,     0,     0,     0,
     139,     0,     0,     0,   132,   111,     0,     0,   121,   118,
     123,   124,   120,   119,   129,   130,   113,   128,   122,   125,
     126,   112,   117,   116,     6,     0,     0,     0,    62,    75,
      77,     0,   101,   102,     0,     0,     0,    52,    51,    50,
       0,     0,     0,     0,    31,     0,     0,   131,     0,    60,
       0,     0,     0,     0,    84,     0,   104,   100,    99,   103,
      42,    42,    42,   140,   117,   117,   108,    58,     0,   136,
      42,    42,    76,     0,    78,    80,    53,    55,    54,    38,
       0,    48,    40,   134,   133,     6,    57,    46,    44,     0,
      85,    89,    90,    36,     0,    43,     0,     0,    59,     0,
       0,     0,    87,    81,    91,    93,     6,     6,     6,     6,
       6,     6,     0,    86,     0,     0,     0,    37,     0,     0,
       0,     0,     0,    88,    92,    82,    94,    39,    49,    41,
      47,    45,    84,    83
};

/* YYDEFGOTO[NTERM-NUM]. */
static const short int yydefgoto[] =
{
      -1,     1,     2,    24,    25,    26,    27,    28,    29,    30,
      75,    31,    49,    32,    42,    43,    33,   236,   224,   227,
     209,    34,   230,    35,   229,    36,   226,   170,   210,    37,
     111,   198,   215,    38,   118,    39,    78,   158,   159,   184,
     185,   222,   245,   262,   204,   231,   220,   233,   234,    44,
      46,   126,    63,   130,    94,   112,    65,   131
};

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
#define YYPACT_NINF -177
static const short int yypact[] =
{
    -177,    11,   128,  -177,  -177,   -12,    -1,    38,    38,    38,
      39,    95,    38,    38,  -177,  -177,  -177,  -177,  -177,  -177,
    -177,  -177,  -177,    95,    31,  -177,  -177,  -177,  -177,  -177,
    -177,   -10,  -177,  -177,  -177,  -177,  -177,  -177,  -177,   -13,
      95,  -177,    73,  -177,    88,  -177,    94,   104,   108,   100,
     106,  -177,   115,   119,  -177,  -177,    95,  -177,  -177,    95,
      95,    95,   124,   127,   358,  -177,   126,   147,   358,   128,
      95,  -177,  -177,  -177,  -177,    95,  -177,  -177,  -177,   280,
      -1,   174,    95,    95,    95,    95,    95,    95,   130,   306,
     112,   462,   112,    95,   144,    95,    95,    95,    95,    95,
      95,    95,    95,    95,    95,    95,    95,    95,    95,    95,
      95,   131,   164,    95,    95,  -177,   358,   358,    -1,  -177,
    -177,  -177,  -177,   174,   174,   174,   101,   188,   188,   188,
     358,    -5,   384,   410,  -177,  -177,   332,    95,   483,   180,
     483,   483,   483,   483,    -8,    -8,   112,    83,   483,   462,
     436,   112,    46,    46,   128,    95,   188,   188,   194,  -177,
     176,   133,   166,   166,   174,   174,   174,  -177,  -177,  -177,
      95,    95,    95,    95,  -177,    95,    95,  -177,     0,    -7,
       2,    95,    95,    -1,   197,   185,  -177,   166,   166,  -177,
     222,   222,   222,   358,   159,   490,  -177,  -177,   204,  -177,
     222,   222,  -177,     1,  -177,  -177,  -177,  -177,  -177,   183,
      95,  -177,  -177,  -177,  -177,   128,  -177,  -177,  -177,    95,
    -177,   358,    95,  -177,   190,   358,   228,   231,    31,   232,
     235,    -4,  -177,   238,  -177,   254,   128,   128,   128,   128,
     128,   128,    95,  -177,    95,   205,    95,  -177,   -30,    17,
      22,    25,    27,  -177,  -177,  -177,   358,  -177,  -177,  -177,
    -177,  -177,   197,  -177
};

/* YYPGOTO[NTERM-NUM].  */
static const short int yypgoto[] =
{
    -177,  -177,  -177,  -132,   -68,  -177,  -177,  -177,  -177,  -177,
    -177,  -177,  -177,  -177,  -177,   168,  -177,  -177,  -177,  -177,
      72,  -177,  -177,  -177,  -177,  -177,  -177,    -6,  -177,  -177,
    -177,  -177,  -177,  -177,  -177,  -177,  -177,  -177,    66,  -177,
    -177,  -177,  -177,  -177,    -2,  -177,  -176,  -177,     8,  -116,
     103,  -108,  -177,   -11,  -177,  -177,  -177,   -76
};

/* YYTABLE[YYPACT[STATE-NUM]].  What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule which
   number is the opposite.  If zero, do what YYDEFACT says.
   If YYTABLE_NINF, syntax error.  */
#define YYTABLE_NINF -108
static const short int yytable[] =
{
      64,   115,   160,   173,   242,   197,    70,    50,   173,    96,
     173,     3,    68,    69,    76,   161,   162,   163,    40,    51,
      52,   257,   179,    41,    53,    54,   104,    55,    77,    79,
     258,    56,    57,    58,    59,   259,    69,   174,   260,    60,
     261,    61,   196,   232,   199,    89,    62,   243,    90,    91,
      92,   219,    71,    72,    73,    74,   187,   188,   189,   116,
      69,   178,    45,    96,   117,    69,   253,   160,    69,   -30,
      69,   127,   128,   129,    69,   132,   133,   101,   102,   180,
     104,    80,   136,   228,   138,   139,   140,   141,   142,   143,
     144,   145,   146,   147,   148,   149,   150,   151,   152,   153,
      96,    50,   156,   157,    81,   248,   249,   250,   251,   252,
      82,    47,    48,    51,    52,    66,    67,  -108,    53,    54,
      83,    55,   171,   172,    84,    56,    57,    58,    59,    96,
      85,     4,     5,    60,   164,    61,    86,     6,     7,     8,
      62,   165,   113,   101,   102,    87,   104,   166,     9,    88,
     181,   182,    10,    11,    93,   -63,   109,  -107,   110,   190,
     191,   192,   193,   114,   194,   195,   164,    12,   247,   -63,
     200,   201,   134,   165,   137,   186,    96,    13,   154,   166,
      14,    15,    16,    17,    18,    19,    20,    21,    22,    23,
     101,   102,   221,   104,   155,   167,   168,    96,   121,   225,
     122,   213,   183,    95,   123,    96,   -79,   124,   221,    97,
      98,   235,   166,   203,   125,   205,    99,   100,   216,   101,
     102,   103,   104,   105,   106,   107,   223,   206,   108,   207,
     208,   221,   109,   235,   110,   256,   169,    95,   238,    96,
     237,   239,   240,    97,    98,   241,   244,   255,   120,   202,
      99,   100,   254,   101,   102,   103,   104,   105,   106,   107,
     263,   246,   108,   211,   212,     0,   109,     0,   110,    95,
       0,    96,   217,   218,     0,    97,    98,     0,     0,     0,
       0,     0,    99,   100,     0,   101,   102,   103,   104,   105,
     106,   107,     0,     0,   108,    95,     0,    96,   109,     0,
     110,    97,    98,     0,     0,     0,     0,     0,    99,   100,
       0,   101,   102,   103,   104,   105,   106,   107,     0,     0,
     108,    95,   119,    96,   109,     0,   110,    97,    98,     0,
       0,     0,     0,     0,    99,   100,     0,   101,   102,   103,
     104,   105,   106,   107,     0,     0,   108,    95,   135,    96,
     109,     0,   110,    97,    98,     0,     0,     0,     0,     0,
      99,   100,     0,   101,   102,   103,   104,   105,   106,   107,
       0,     0,   108,    95,   177,    96,   109,     0,   110,    97,
      98,     0,     0,     0,     0,     0,    99,   100,     0,   101,
     102,   103,   104,   105,   106,   107,     0,     0,   108,    95,
       0,    96,   109,     0,   110,    97,    98,     0,     0,     0,
       0,     0,    99,   100,     0,   101,   102,   103,   104,   105,
     106,   107,     0,     0,   108,    95,     0,    96,   175,     0,
     110,    97,    98,     0,     0,     0,     0,     0,    99,   100,
       0,   101,   102,   103,   104,   105,   106,   107,     0,     0,
     108,    95,     0,    96,   176,     0,   110,    97,    98,     0,
       0,     0,     0,     0,    99,   100,     0,   101,   102,   103,
     104,   105,   106,     0,     0,     0,   108,    95,     0,    96,
     109,     0,   110,    97,    98,     0,     0,     0,     0,     0,
      99,   100,     0,   101,   102,   103,   104,   105,  -108,     0,
      96,     0,   108,     0,  -108,  -108,   109,    96,   110,     0,
       0,  -108,  -108,     0,   101,   102,   103,   104,  -108,     0,
       0,   101,   102,   108,   104,     0,     0,   109,     0,   110,
       0,     0,   214
};

static const short int yycheck[] =
{
      11,    69,   118,     8,     8,    12,    16,     6,     8,    17,
       8,     0,    23,    43,    27,   123,   124,   125,    30,    18,
      19,    51,   154,    24,    23,    24,    34,    26,    41,    40,
      13,    30,    31,    32,    33,    13,    43,    42,    13,    38,
      13,    40,    42,   219,    42,    56,    45,    51,    59,    60,
      61,    50,    62,    63,    64,    65,   164,   165,   166,    70,
      43,   137,    24,    17,    75,    43,   242,   183,    43,    30,
      43,    82,    83,    84,    43,    86,    87,    31,    32,   155,
      34,     8,    93,   215,    95,    96,    97,    98,    99,   100,
     101,   102,   103,   104,   105,   106,   107,   108,   109,   110,
      17,     6,   113,   114,    16,   237,   238,   239,   240,   241,
      16,     8,     9,    18,    19,    12,    13,    34,    23,    24,
      16,    26,   128,   129,    16,    30,    31,    32,    33,    17,
      30,     3,     4,    38,    33,    40,    30,     9,    10,    11,
      45,    40,    16,    31,    32,    30,    34,    46,    20,    30,
     156,   157,    24,    25,    30,    27,    44,    30,    46,   170,
     171,   172,   173,    16,   175,   176,    33,    39,   236,    41,
     181,   182,    42,    40,    30,    42,    17,    49,    47,    46,
      52,    53,    54,    55,    56,    57,    58,    59,    60,    61,
      31,    32,   203,    34,    30,     7,     8,    17,    24,   210,
      26,    42,     8,    15,    30,    17,    30,    33,   219,    21,
      22,   222,    46,    16,    40,    30,    28,    29,    14,    31,
      32,    33,    34,    35,    36,    37,    43,     5,    40,     7,
       8,   242,    44,   244,    46,   246,    48,    15,    10,    17,
      50,    10,    10,    21,    22,    10,     8,    42,    80,   183,
      28,    29,   244,    31,    32,    33,    34,    35,    36,    37,
     262,     7,    40,   191,   192,    -1,    44,    -1,    46,    15,
      -1,    17,   200,   201,    -1,    21,    22,    -1,    -1,    -1,
      -1,    -1,    28,    29,    -1,    31,    32,    33,    34,    35,
      36,    37,    -1,    -1,    40,    15,    -1,    17,    44,    -1,
      46,    21,    22,    -1,    -1,    -1,    -1,    -1,    28,    29,
      -1,    31,    32,    33,    34,    35,    36,    37,    -1,    -1,
      40,    15,    42,    17,    44,    -1,    46,    21,    22,    -1,
      -1,    -1,    -1,    -1,    28,    29,    -1,    31,    32,    33,
      34,    35,    36,    37,    -1,    -1,    40,    15,    42,    17,
      44,    -1,    46,    21,    22,    -1,    -1,    -1,    -1,    -1,
      28,    29,    -1,    31,    32,    33,    34,    35,    36,    37,
      -1,    -1,    40,    15,    42,    17,    44,    -1,    46,    21,
      22,    -1,    -1,    -1,    -1,    -1,    28,    29,    -1,    31,
      32,    33,    34,    35,    36,    37,    -1,    -1,    40,    15,
      -1,    17,    44,    -1,    46,    21,    22,    -1,    -1,    -1,
      -1,    -1,    28,    29,    -1,    31,    32,    33,    34,    35,
      36,    37,    -1,    -1,    40,    15,    -1,    17,    44,    -1,
      46,    21,    22,    -1,    -1,    -1,    -1,    -1,    28,    29,
      -1,    31,    32,    33,    34,    35,    36,    37,    -1,    -1,
      40,    15,    -1,    17,    44,    -1,    46,    21,    22,    -1,
      -1,    -1,    -1,    -1,    28,    29,    -1,    31,    32,    33,
      34,    35,    36,    -1,    -1,    -1,    40,    15,    -1,    17,
      44,    -1,    46,    21,    22,    -1,    -1,    -1,    -1,    -1,
      28,    29,    -1,    31,    32,    33,    34,    35,    15,    -1,
      17,    -1,    40,    -1,    21,    22,    44,    17,    46,    -1,
      -1,    28,    29,    -1,    31,    32,    33,    34,    35,    -1,
      -1,    31,    32,    40,    34,    -1,    -1,    44,    -1,    46,
      -1,    -1,    42
};

/* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
   symbol of state STATE-NUM.  */
static const unsigned char yystos[] =
{
       0,    67,    68,     0,     3,     4,     9,    10,    11,    20,
      24,    25,    39,    49,    52,    53,    54,    55,    56,    57,
      58,    59,    60,    61,    69,    70,    71,    72,    73,    74,
      75,    77,    79,    82,    87,    89,    91,    95,    99,   101,
      30,    24,    80,    81,   115,    24,   116,   116,   116,    78,
       6,    18,    19,    23,    24,    26,    30,    31,    32,    33,
      38,    40,    45,   118,   119,   122,   116,   116,   119,    43,
      16,    62,    63,    64,    65,    76,    27,    41,   102,   119,
       8,    16,    16,    16,    16,    30,    30,    30,    30,   119,
     119,   119,   119,    30,   120,    15,    17,    21,    22,    28,
      29,    31,    32,    33,    34,    35,    36,    37,    40,    44,
      46,    96,   121,    16,    16,    70,   119,   119,   100,    42,
      81,    24,    26,    30,    33,    40,   117,   119,   119,   119,
     119,   123,   119,   119,    42,    42,   119,    30,   119,   119,
     119,   119,   119,   119,   119,   119,   119,   119,   119,   119,
     119,   119,   119,   119,    47,    30,   119,   119,   103,   104,
     115,   117,   117,   117,    33,    40,    46,     7,     8,    48,
      93,    93,    93,     8,    42,    44,    44,    42,   123,    69,
     123,    93,    93,     8,   105,   106,    42,   117,   117,   117,
     119,   119,   119,   119,   119,   119,    42,    12,    97,    42,
     119,   119,   104,    16,   110,    30,     5,     7,     8,    86,
      94,    86,    86,    42,    42,    98,    14,    86,    86,    50,
     112,   119,   107,    43,    84,   119,    92,    85,    69,    90,
      88,   111,   112,   113,   114,   119,    83,    50,    10,    10,
      10,    10,     8,    51,     8,   108,     7,    70,    69,    69,
      69,    69,    69,   112,   114,    42,   119,    51,    13,    13,
      13,    13,   109,   110
};

#if ! defined (YYSIZE_T) && defined (__SIZE_TYPE__)
# define YYSIZE_T __SIZE_TYPE__
#endif
#if ! defined (YYSIZE_T) && defined (size_t)
# define YYSIZE_T size_t
#endif
#if ! defined (YYSIZE_T)
# if defined (__STDC__) || defined (__cplusplus)
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# endif
#endif
#if ! defined (YYSIZE_T)
# define YYSIZE_T unsigned int
#endif

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		(-2)
#define YYEOF		0

#define YYACCEPT	goto yyacceptlab
#define YYABORT		goto yyabortlab
#define YYERROR		goto yyerrorlab


/* Like YYERROR except do call yyerror.  This remains here temporarily
   to ease the transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  */

#define YYFAIL		goto yyerrlab

#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)					\
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    {								\
      yychar = (Token);						\
      yylval = (Value);						\
      yytoken = YYTRANSLATE (yychar);				\
      YYPOPSTACK;						\
      goto yybackup;						\
    }								\
  else								\
    { 								\
      yyerror ("syntax error: cannot back up");\
      YYERROR;							\
    }								\
while (0)


#define YYTERROR	1
#define YYERRCODE	256


/* YYLLOC_DEFAULT -- Set CURRENT to span from RHS[1] to RHS[N].
   If N is 0, then set CURRENT to the empty location which ends
   the previous symbol: RHS[0] (always defined).  */

#define YYRHSLOC(Rhs, K) ((Rhs)[K])
#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)				\
    do									\
      if (N)								\
	{								\
	  (Current).first_line   = YYRHSLOC (Rhs, 1).first_line;	\
	  (Current).first_column = YYRHSLOC (Rhs, 1).first_column;	\
	  (Current).last_line    = YYRHSLOC (Rhs, N).last_line;		\
	  (Current).last_column  = YYRHSLOC (Rhs, N).last_column;	\
	}								\
      else								\
	{								\
	  (Current).first_line   = (Current).last_line   =		\
	    YYRHSLOC (Rhs, 0).last_line;				\
	  (Current).first_column = (Current).last_column =		\
	    YYRHSLOC (Rhs, 0).last_column;				\
	}								\
    while (0)
#endif


/* YY_LOCATION_PRINT -- Print the location on the stream.
   This macro was not mandated originally: define only if we know
   we won't break user code: when these are the locations we know.  */

#ifndef YY_LOCATION_PRINT
# if YYLTYPE_IS_TRIVIAL
#  define YY_LOCATION_PRINT(File, Loc)			\
     fprintf (File, "%d.%d-%d.%d",			\
              (Loc).first_line, (Loc).first_column,	\
              (Loc).last_line,  (Loc).last_column)
# else
#  define YY_LOCATION_PRINT(File, Loc) ((void) 0)
# endif
#endif


/* YYLEX -- calling `yylex' with the right arguments.  */

#ifdef YYLEX_PARAM
# define YYLEX yylex (YYLEX_PARAM)
#else
# define YYLEX yylex ()
#endif

/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)			\
do {						\
  if (yydebug)					\
    YYFPRINTF Args;				\
} while (0)

# define YY_SYMBOL_PRINT(Title, Type, Value, Location)		\
do {								\
  if (yydebug)							\
    {								\
      YYFPRINTF (stderr, "%s ", Title);				\
      yysymprint (stderr, 					\
                  Type, Value);	\
      YYFPRINTF (stderr, "\n");					\
    }								\
} while (0)

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

#if defined (__STDC__) || defined (__cplusplus)
static void
yy_stack_print (short int *bottom, short int *top)
#else
static void
yy_stack_print (bottom, top)
    short int *bottom;
    short int *top;
#endif
{
  YYFPRINTF (stderr, "Stack now");
  for (/* Nothing. */; bottom <= top; ++bottom)
    YYFPRINTF (stderr, " %d", *bottom);
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)				\
do {								\
  if (yydebug)							\
    yy_stack_print ((Bottom), (Top));				\
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

#if defined (__STDC__) || defined (__cplusplus)
static void
yy_reduce_print (int yyrule)
#else
static void
yy_reduce_print (yyrule)
    int yyrule;
#endif
{
  int yyi;
  unsigned int yylno = yyrline[yyrule];
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %u), ",
             yyrule - 1, yylno);
  /* Print the symbols being reduced, and their result.  */
  for (yyi = yyprhs[yyrule]; 0 <= yyrhs[yyi]; yyi++)
    YYFPRINTF (stderr, "%s ", yytname [yyrhs[yyi]]);
  YYFPRINTF (stderr, "-> %s\n", yytname [yyr1[yyrule]]);
}

# define YY_REDUCE_PRINT(Rule)		\
do {					\
  if (yydebug)				\
    yy_reduce_print (Rule);		\
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef	YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   SIZE_MAX < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif



#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined (__GLIBC__) && defined (_STRING_H)
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
static YYSIZE_T
#   if defined (__STDC__) || defined (__cplusplus)
yystrlen (const char *yystr)
#   else
yystrlen (yystr)
     const char *yystr;
#   endif
{
  register const char *yys = yystr;

  while (*yys++ != '\0')
    continue;

  return yys - yystr - 1;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined (__GLIBC__) && defined (_STRING_H) && defined (_GNU_SOURCE)
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
static char *
#   if defined (__STDC__) || defined (__cplusplus)
yystpcpy (char *yydest, const char *yysrc)
#   else
yystpcpy (yydest, yysrc)
     char *yydest;
     const char *yysrc;
#   endif
{
  register char *yyd = yydest;
  register const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

#endif /* !YYERROR_VERBOSE */



#if YYDEBUG
/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

#if defined (__STDC__) || defined (__cplusplus)
static void
yysymprint (FILE *yyoutput, int yytype, YYSTYPE *yyvaluep)
#else
static void
yysymprint (yyoutput, yytype, yyvaluep)
    FILE *yyoutput;
    int yytype;
    YYSTYPE *yyvaluep;
#endif
{
  /* Pacify ``unused variable'' warnings.  */
  (void) yyvaluep;

  if (yytype < YYNTOKENS)
    YYFPRINTF (yyoutput, "token %s (", yytname[yytype]);
  else
    YYFPRINTF (yyoutput, "nterm %s (", yytname[yytype]);


# ifdef YYPRINT
  if (yytype < YYNTOKENS)
    YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# endif
  switch (yytype)
    {
      default:
        break;
    }
  YYFPRINTF (yyoutput, ")");
}

#endif /* ! YYDEBUG */
/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

#if defined (__STDC__) || defined (__cplusplus)
static void
yydestruct (const char *yymsg, int yytype, YYSTYPE *yyvaluep)
#else
static void
yydestruct (yymsg, yytype, yyvaluep)
    const char *yymsg;
    int yytype;
    YYSTYPE *yyvaluep;
#endif
{
  /* Pacify ``unused variable'' warnings.  */
  (void) yyvaluep;

  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);

  switch (yytype)
    {

      default:
        break;
    }
}


/* Prevent warnings from -Wmissing-prototypes.  */

#ifdef YYPARSE_PARAM
# if defined (__STDC__) || defined (__cplusplus)
int yyparse (void *YYPARSE_PARAM);
# else
int yyparse ();
# endif
#else /* ! YYPARSE_PARAM */
#if defined (__STDC__) || defined (__cplusplus)
int yyparse (void);
#else
int yyparse ();
#endif
#endif /* ! YYPARSE_PARAM */



/* The look-ahead symbol.  */
int yychar;

/* The semantic value of the look-ahead symbol.  */
YYSTYPE yylval;

/* Number of syntax errors so far.  */
int yynerrs;



/*----------.
| yyparse.  |
`----------*/

#ifdef YYPARSE_PARAM
# if defined (__STDC__) || defined (__cplusplus)
int yyparse (void *YYPARSE_PARAM)
# else
int yyparse (YYPARSE_PARAM)
  void *YYPARSE_PARAM;
# endif
#else /* ! YYPARSE_PARAM */
#if defined (__STDC__) || defined (__cplusplus)
int
yyparse (void)
#else
int
yyparse ()

#endif
#endif
{
  
  register int yystate;
  register int yyn;
  int yyresult;
  /* Number of tokens to shift before error messages enabled.  */
  int yyerrstatus;
  /* Look-ahead token as an internal (translated) token number.  */
  int yytoken = 0;

  /* Three stacks and their tools:
     `yyss': related to states,
     `yyvs': related to semantic values,
     `yyls': related to locations.

     Refer to the stacks thru separate pointers, to allow yyoverflow
     to reallocate them elsewhere.  */

  /* The state stack.  */
  short int yyssa[YYINITDEPTH];
  short int *yyss = yyssa;
  register short int *yyssp;

  /* The semantic value stack.  */
  YYSTYPE yyvsa[YYINITDEPTH];
  YYSTYPE *yyvs = yyvsa;
  register YYSTYPE *yyvsp;



#define YYPOPSTACK   (yyvsp--, yyssp--)

  YYSIZE_T yystacksize = YYINITDEPTH;

  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;


  /* When reducing, the number of symbols on the RHS of the reduced
     rule.  */
  int yylen;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY;		/* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */

  yyssp = yyss;
  yyvsp = yyvs;


  yyvsp[0] = yylval;

  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed. so pushing a state here evens the stacks.
     */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
	/* Give user a chance to reallocate the stack. Use copies of
	   these so that the &'s don't force the real ones into
	   memory.  */
	YYSTYPE *yyvs1 = yyvs;
	short int *yyss1 = yyss;


	/* Each stack pointer address is followed by the size of the
	   data in use in that stack, in bytes.  This used to be a
	   conditional around just the two extra args, but that might
	   be undefined if yyoverflow is a macro.  */
	yyoverflow ("parser stack overflow",
		    &yyss1, yysize * sizeof (*yyssp),
		    &yyvs1, yysize * sizeof (*yyvsp),

		    &yystacksize);

	yyss = yyss1;
	yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyoverflowlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
	goto yyoverflowlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
	yystacksize = YYMAXDEPTH;

      {
	short int *yyss1 = yyss;
	union yyalloc *yyptr =
	  (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
	if (! yyptr)
	  goto yyoverflowlab;
	YYSTACK_RELOCATE (yyss);
	YYSTACK_RELOCATE (yyvs);

#  undef YYSTACK_RELOCATE
	if (yyss1 != yyssa)
	  YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;


      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
		  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
	YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

/* Do appropriate processing given the current state.  */
/* Read a look-ahead token if we need one and don't already have one.  */
/* yyresume: */

  /* First try to decide what to do without reference to look-ahead token.  */

  yyn = yypact[yystate];
  if (yyn == YYPACT_NINF)
    goto yydefault;

  /* Not known => get a look-ahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid look-ahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = YYLEX;
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yyn == 0 || yyn == YYTABLE_NINF)
	goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  if (yyn == YYFINAL)
    YYACCEPT;

  /* Shift the look-ahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);

  /* Discard the token being shifted unless it is eof.  */
  if (yychar != YYEOF)
    yychar = YYEMPTY;

  *++yyvsp = yylval;


  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  yystate = yyn;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     `$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 2:
#line 170 "../../../../../git/pers/barvinok/omega/petit/src/petity.y"
    {
	  parse_init();
	  ShouldBeEnd = 0;
	}
    break;

  case 3:
#line 175 "../../../../../git/pers/barvinok/omega/petit/src/petity.y"
    {
	  P_Node = make_node(op_exit);
	  ExitNode = P_Node;
	  parse_linknode(P_Node);
	}
    break;

  case 9:
#line 192 "../../../../../git/pers/barvinok/omega/petit/src/petity.y"
    {CheckEnd();}
    break;

  case 10:
#line 193 "../../../../../git/pers/barvinok/omega/petit/src/petity.y"
    {CheckEnd();}
    break;

  case 12:
#line 195 "../../../../../git/pers/barvinok/omega/petit/src/petity.y"
    {CheckEnd();}
    break;

  case 13:
#line 196 "../../../../../git/pers/barvinok/omega/petit/src/petity.y"
    {CheckEnd();}
    break;

  case 14:
#line 197 "../../../../../git/pers/barvinok/omega/petit/src/petity.y"
    {CheckEnd();}
    break;

  case 15:
#line 198 "../../../../../git/pers/barvinok/omega/petit/src/petity.y"
    {CheckEnd();}
    break;

  case 16:
#line 199 "../../../../../git/pers/barvinok/omega/petit/src/petity.y"
    {CheckEnd();}
    break;

  case 18:
#line 201 "../../../../../git/pers/barvinok/omega/petit/src/petity.y"
    {ShouldBeEnd=1;}
    break;

  case 19:
#line 204 "../../../../../git/pers/barvinok/omega/petit/src/petity.y"
    {}
    break;

  case 20:
#line 205 "../../../../../git/pers/barvinok/omega/petit/src/petity.y"
    {free_node((yyvsp[0].np));}
    break;

  case 21:
#line 209 "../../../../../git/pers/barvinok/omega/petit/src/petity.y"
    {
		    parse_check_stmt_number();   /* what the heck... */
		    P_Node = make_node( op_assert );
		    P_Node->nodelink = Assertions;
		    Assertions = P_Node;
		    parse_linknode( P_Node );
		    parse_pushscope( P_Node );
		    parse_linknode( (yyvsp[-1].np) );
		    parse_popscope();
		}
    break;

  case 22:
#line 221 "../../../../../git/pers/barvinok/omega/petit/src/petity.y"
    {
                if(1) {
		    P_Sym = parse_symbol(-1);
		    P_Node = make_node( op_comment );
		    P_Node->nodevalue = (unsigned long int)P_Sym;
		    parse_linknode( P_Node );
		    P_Sym->symtype = symcomment;
		    P_Sym->symdims = (unsigned) -1;
		    P_Sym->symdecl = P_Node;

		    P_Sym->exptype = exprint; /* cexpr's are only integers */
		  }
		}
    break;

  case 23:
#line 238 "../../../../../git/pers/barvinok/omega/petit/src/petity.y"
    {
		  node *rp = (yyvsp[0].np);

		  parse_check_stmt_number();
		  P_Node = make_node( op_assign );
		  
		  /* make sure types are compatible */
		  /* note: refreal can accept any type */
		  if( (yyvsp[-2].np)->exptype == exprrefint && rp->exptype != exprint ) {
		    rp = make_node(op_rtoi);
		    rp->exptype = exprrefint;
		    rp->nodechild = (yyvsp[0].np);
		    ((yyvsp[0].np))->nodeparent = rp;
		  }
		  
		  parse_linknodeto( P_Node, rp );
		  parse_linknodeto( P_Node, (yyvsp[-2].np) );
		  parse_linknode( P_Node );
		}
    break;

  case 24:
#line 261 "../../../../../git/pers/barvinok/omega/petit/src/petity.y"
    {
		  optype *pop;
		  
		  parse_check_stmt_number();
		  P_Node = make_node((yyvsp[-1].op));
		  
		  /* make sure types are compatible */
		  /* note: refreal can accept any type */
		  if( (yyvsp[-2].np)->exptype == exprrefint && (yyvsp[0].np)->exptype != exprint ) {
		    fprintf(stderr, "*** can't assign real to integer\n");
		    parse_die();
		  }

		  parse_linknodeto( P_Node, (yyvsp[0].np) );
		  parse_linknodeto( P_Node, (yyvsp[-2].np) );
		  parse_linknode( P_Node );

		  pop = &P_Node->nodechild->nodenext->nodeop;
		  if(*pop==op_store) {
		    *pop = op_update;
		  } else if(*pop==op_store_array) {
		    *pop = op_update_array;
		  }
                }
    break;

  case 25:
#line 288 "../../../../../git/pers/barvinok/omega/petit/src/petity.y"
    {(yyval.op) = op_add_assign;}
    break;

  case 26:
#line 289 "../../../../../git/pers/barvinok/omega/petit/src/petity.y"
    {(yyval.op) = op_mul_assign;}
    break;

  case 27:
#line 290 "../../../../../git/pers/barvinok/omega/petit/src/petity.y"
    {(yyval.op) = op_max_assign;}
    break;

  case 28:
#line 291 "../../../../../git/pers/barvinok/omega/petit/src/petity.y"
    {(yyval.op) = op_min_assign;}
    break;

  case 29:
#line 297 "../../../../../git/pers/barvinok/omega/petit/src/petity.y"
    {
		    P_Sym = parse_symbol(0);
		    if( P_Sym->symdims > 0 ){
			fprintf(stderr, "*** lhs array must have %d subscripts: %s\n", 
				P_Sym->symdims, P_Sym->symname );
			parse_die();
		    }
		    if( P_Sym->symtype == symconst ){
			fprintf(stderr, "*** lhs must be variable: %s\n",
				P_Sym->symname );
			parse_die();
		    }
		    if( P_Sym->symtype == symindex ){
			fprintf(stderr, "*** lhs cannot be loop index: %s\n",
				P_Sym->symname );
			parse_die();
		    }

		    P_Node = make_node( op_store );
		    P_Node->nodevalue = (unsigned long int)P_Sym->symdecl;

		    P_Node->exptype = P_Sym->exptype; /* refint or refreal */

		    (yyval.np) = P_Node;
		}
    break;

  case 30:
#line 324 "../../../../../git/pers/barvinok/omega/petit/src/petity.y"
    {
		    P_Sym = parse_symbol(0);
		    if( P_Sym->symdims <= 0 ){
			fprintf(stderr, "*** not an array: %s\n", P_Sym->symname );
			parse_die();
		    }
		    P_Node = make_node( op_store_array );
		    P_Node->nodevalue = (unsigned long int)P_Sym->symdecl;

		    if( P_Sym->exptype == exprintarray )
			P_Node->exptype = exprrefint;
		    else
		    if( P_Sym->exptype == exprrealarray )
			P_Node->exptype = exprrefreal;
		    else
			P_Node->exptype = exprunknown;

		    parse_linknode( P_Node );
		    parse_pushscope( P_Node ); 
		    (yyval.np) = P_Node;
		    /* save it because it can be reassigned down there */
		    P_Sym1 = P_Sym; 
		}
    break;

  case 31:
#line 348 "../../../../../git/pers/barvinok/omega/petit/src/petity.y"
    {
		    /* make sure all subscripts are integer expressions */
		    int count = 0;
		    for( P_Node = ((yyvsp[-3].np))->nodechild; P_Node != NULL;
				      P_Node = P_Node->nodenext ){
		        count++;
			if( P_Node->exptype != exprint ) {
			    fprintf(stderr, "*** All subscripts must be integer\n" );
			    parse_die();
			}
		    }
		    if(count != (int)P_Sym1->symdims) {
			fprintf(stderr, "*** Wrong number of subscripts in %s (store)\n", P_Sym1->symname );
			parse_die();
		    }

		    parse_popscope();
		    parse_unlinknode();
		    (yyval.np) = (yyvsp[-3].np);
		}
    break;

  case 32:
#line 371 "../../../../../git/pers/barvinok/omega/petit/src/petity.y"
    {}
    break;

  case 35:
#line 382 "../../../../../git/pers/barvinok/omega/petit/src/petity.y"
    {
		    P_Sym = (yyvsp[-2].stp);
		    P_Node = make_node( op_declare );
		    P_Node->nodevalue = (unsigned long int)P_Sym;
		    parse_linknode( P_Node );
		    P_Sym->symtype = symconst;
		    P_Sym->symdims = (unsigned) -1;
		    P_Sym->symvalue = (yyvsp[0].iv);
		    P_Sym->symdecl = P_Node;

		    P_Sym->exptype = exprint; /* cexpr's are only integers */
		}
    break;

  case 36:
#line 398 "../../../../../git/pers/barvinok/omega/petit/src/petity.y"
    { parse_forloop( op_do, (yyvsp[-6].stp), (yyvsp[-4].np), (yyvsp[-2].np), (yyvsp[-1].np) ); }
    break;

  case 37:
#line 400 "../../../../../git/pers/barvinok/omega/petit/src/petity.y"
    { parse_endforloop(); }
    break;

  case 38:
#line 403 "../../../../../git/pers/barvinok/omega/petit/src/petity.y"
    { parse_forloop( op_do, (yyvsp[-5].stp), (yyvsp[-3].np), (yyvsp[-1].np), (yyvsp[0].np) ); }
    break;

  case 39:
#line 405 "../../../../../git/pers/barvinok/omega/petit/src/petity.y"
    { parse_endforloop(); }
    break;

  case 40:
#line 408 "../../../../../git/pers/barvinok/omega/petit/src/petity.y"
    { parse_forloop( op_do, (yyvsp[-5].stp), (yyvsp[-3].np), (yyvsp[-1].np), (yyvsp[0].np) ); }
    break;

  case 41:
#line 410 "../../../../../git/pers/barvinok/omega/petit/src/petity.y"
    { parse_endforloop(); }
    break;

  case 42:
#line 414 "../../../../../git/pers/barvinok/omega/petit/src/petity.y"
    {(yyval.np) = NULL;}
    break;

  case 43:
#line 415 "../../../../../git/pers/barvinok/omega/petit/src/petity.y"
    {(yyval.np) = (yyvsp[0].np);}
    break;

  case 44:
#line 421 "../../../../../git/pers/barvinok/omega/petit/src/petity.y"
    {
		    parse_forloop( op_dovec, (yyvsp[-5].stp), (yyvsp[-3].np), (yyvsp[-1].np), (yyvsp[0].np) );
		}
    break;

  case 45:
#line 425 "../../../../../git/pers/barvinok/omega/petit/src/petity.y"
    {
		    parse_endforloop();
		}
    break;

  case 46:
#line 432 "../../../../../git/pers/barvinok/omega/petit/src/petity.y"
    {
		    parse_forloop( op_dopar, (yyvsp[-5].stp), (yyvsp[-3].np), (yyvsp[-1].np), (yyvsp[0].np) );
		}
    break;

  case 47:
#line 436 "../../../../../git/pers/barvinok/omega/petit/src/petity.y"
    {
		    parse_endforloop();
		}
    break;

  case 48:
#line 443 "../../../../../git/pers/barvinok/omega/petit/src/petity.y"
    {
		    parse_forloop( op_doany, (yyvsp[-5].stp), (yyvsp[-3].np), (yyvsp[-1].np), (yyvsp[0].np) );
		}
    break;

  case 49:
#line 447 "../../../../../git/pers/barvinok/omega/petit/src/petity.y"
    {
		    parse_endforloop();
		}
    break;

  case 50:
#line 453 "../../../../../git/pers/barvinok/omega/petit/src/petity.y"
    {}
    break;

  case 51:
#line 455 "../../../../../git/pers/barvinok/omega/petit/src/petity.y"
    {}
    break;

  case 52:
#line 457 "../../../../../git/pers/barvinok/omega/petit/src/petity.y"
    {}
    break;

  case 53:
#line 461 "../../../../../git/pers/barvinok/omega/petit/src/petity.y"
    {}
    break;

  case 54:
#line 463 "../../../../../git/pers/barvinok/omega/petit/src/petity.y"
    {}
    break;

  case 55:
#line 465 "../../../../../git/pers/barvinok/omega/petit/src/petity.y"
    {}
    break;

  case 56:
#line 470 "../../../../../git/pers/barvinok/omega/petit/src/petity.y"
    {
		    parse_check_stmt_number();
		    P_Node = make_node( op_if );

		    parse_linknode( P_Node );
		    parse_pushscope( P_Node );
		    parse_linknode( (yyvsp[0].np) );
		    P_Node = make_node( op_then );
		    parse_linknode( P_Node );
		    parse_pushscope( P_Node );
		}
    break;

  case 57:
#line 484 "../../../../../git/pers/barvinok/omega/petit/src/petity.y"
    {
		    parse_popscope();
		    parse_popscope();
		}
    break;

  case 58:
#line 493 "../../../../../git/pers/barvinok/omega/petit/src/petity.y"
    {   parse_popscope();
		    P_Node = make_node( op_else );
		    parse_linknode( P_Node );
		    parse_pushscope( P_Node );
		}
    break;

  case 61:
#line 502 "../../../../../git/pers/barvinok/omega/petit/src/petity.y"
    {SaveClass=(var_class) (yyvsp[-1].iv); P_SaveType=(symboltype) (yyvsp[0].iv);}
    break;

  case 63:
#line 505 "../../../../../git/pers/barvinok/omega/petit/src/petity.y"
    {(yyval.iv) = CLunknown;}
    break;

  case 64:
#line 506 "../../../../../git/pers/barvinok/omega/petit/src/petity.y"
    {(yyval.iv) = CLAUTO;}
    break;

  case 65:
#line 507 "../../../../../git/pers/barvinok/omega/petit/src/petity.y"
    {(yyval.iv) = CLCOMMON;}
    break;

  case 66:
#line 508 "../../../../../git/pers/barvinok/omega/petit/src/petity.y"
    {(yyval.iv) = CLSTATIC;}
    break;

  case 67:
#line 509 "../../../../../git/pers/barvinok/omega/petit/src/petity.y"
    {(yyval.iv) = CLFORMAL;}
    break;

  case 68:
#line 510 "../../../../../git/pers/barvinok/omega/petit/src/petity.y"
    {(yyval.iv) = CLIN;}
    break;

  case 69:
#line 511 "../../../../../git/pers/barvinok/omega/petit/src/petity.y"
    {(yyval.iv) = CLOUT;}
    break;

  case 70:
#line 512 "../../../../../git/pers/barvinok/omega/petit/src/petity.y"
    {(yyval.iv) = CLINOUT;}
    break;

  case 71:
#line 513 "../../../../../git/pers/barvinok/omega/petit/src/petity.y"
    {(yyval.iv) = CLPRIVATE;}
    break;

  case 72:
#line 514 "../../../../../git/pers/barvinok/omega/petit/src/petity.y"
    {(yyval.iv) = CLBUILTIN;}
    break;

  case 73:
#line 517 "../../../../../git/pers/barvinok/omega/petit/src/petity.y"
    {(yyval.iv)=syminteger;}
    break;

  case 74:
#line 518 "../../../../../git/pers/barvinok/omega/petit/src/petity.y"
    {(yyval.iv)=symreal;}
    break;

  case 77:
#line 530 "../../../../../git/pers/barvinok/omega/petit/src/petity.y"
    {
		    P_DeclSym = (yyvsp[0].stp);
		    P_Node = make_node( op_declare );
		    P_Node->nodevalue = (unsigned long int)P_DeclSym;
		    parse_linknode( P_Node );
		    P_DeclSym->symtype = P_SaveType;
		    P_DeclSym->symdims = 0;
		    P_DeclSym->symdecl = P_Node;
		    if(SaveClass == CLBUILTIN) {
		      fprintf(stderr, "Not function %s\n", (yyvsp[0].stp)->symname);
		      parse_die();
		    }
		    P_DeclSym->symclass =
		      SaveClass==CLunknown ? CLAUTO : SaveClass;

		    /* determine the type based on declaration */
		    if( P_SaveType == syminteger )
			P_DeclSym->exptype = exprrefint;
		    else if( P_SaveType == symreal )
			P_DeclSym->exptype = exprrefreal;
		    else
			P_DeclSym->exptype = exprunknown;
		}
    break;

  case 79:
#line 556 "../../../../../git/pers/barvinok/omega/petit/src/petity.y"
    {
		    P_DeclSym = (yyvsp[0].stp);
		    P_Node = make_node( op_declare );
		    P_Node->nodevalue = (unsigned long int)P_DeclSym;
		    parse_linknode( P_Node );
		    parse_pushscope( P_Node );
		    P_DeclSym->symtype = P_SaveType;
		    P_DeclSym->symdecl = P_Node;
		    P_DeclSym->symclass = SaveClass==CLunknown ?
		      (1 ? CLINOUT : CLAUTO) : SaveClass;
		}
    break;

  case 80:
#line 567 "../../../../../git/pers/barvinok/omega/petit/src/petity.y"
    {NoNewOldCheck=1;}
    break;

  case 81:
#line 567 "../../../../../git/pers/barvinok/omega/petit/src/petity.y"
    {NoNewOldCheck=0;}
    break;

  case 82:
#line 568 "../../../../../git/pers/barvinok/omega/petit/src/petity.y"
    {
		    /* determine the type based on declaration */
		    if(P_DeclSym->symdims!=DIMSFUN || SaveClass!=CLBUILTIN) {
		      if(P_DeclSym->symdims==DIMSFUN) {
			P_DeclSym->symdims = 1;
		      }
		      if( P_SaveType == syminteger )
			P_DeclSym->exptype = exprintarray;
		      else if( P_SaveType == symreal )
			P_DeclSym->exptype = exprrealarray;
		      else
			P_DeclSym->exptype = exprunknown;
		    } else {
		      if( P_SaveType == syminteger )
			P_DeclSym->exptype = exprintfun;
		      else if( P_SaveType == symreal )
			P_DeclSym->exptype = exprrealfun;
		      else
			P_DeclSym->exptype = exprunknown;
		    }

		    parse_popscope();
		}
    break;

  case 85:
#line 596 "../../../../../git/pers/barvinok/omega/petit/src/petity.y"
    {}
    break;

  case 86:
#line 597 "../../../../../git/pers/barvinok/omega/petit/src/petity.y"
    {}
    break;

  case 89:
#line 603 "../../../../../git/pers/barvinok/omega/petit/src/petity.y"
    {free_node((yyvsp[0].np));}
    break;

  case 90:
#line 608 "../../../../../git/pers/barvinok/omega/petit/src/petity.y"
    {   P_DeclSym->symdims = DIMSFUN; }
    break;

  case 91:
#line 609 "../../../../../git/pers/barvinok/omega/petit/src/petity.y"
    {   P_DeclSym->symdims = 1; }
    break;

  case 92:
#line 610 "../../../../../git/pers/barvinok/omega/petit/src/petity.y"
    {   P_DeclSym->symdims++; }
    break;

  case 93:
#line 615 "../../../../../git/pers/barvinok/omega/petit/src/petity.y"
    {
		    P_Node = make_node( op_bounds );
		    parse_linknode( P_Node );
		    parse_pushscope( P_Node );

		    P_Node = make_node( op_constant );
		    P_Node->nodevalue = 1;
		    parse_linknode( P_Node );

		    P_Node = (yyvsp[0].np);
		    parse_linknode( P_Node );
		    parse_popscope();
		}
    break;

  case 94:
#line 630 "../../../../../git/pers/barvinok/omega/petit/src/petity.y"
    {
		    P_Node = make_node( op_bounds );
		    parse_linknode( P_Node );
		    parse_pushscope( P_Node );

		    P_Node = (yyvsp[-2].np);
		    parse_linknode( P_Node );

		    P_Node = (yyvsp[0].np);
		    parse_linknode( P_Node );
		    parse_popscope();
		}
    break;

  case 95:
#line 646 "../../../../../git/pers/barvinok/omega/petit/src/petity.y"
    {   (yyval.stp) = parse_symbol(1); }
    break;

  case 96:
#line 651 "../../../../../git/pers/barvinok/omega/petit/src/petity.y"
    {   (yyval.stp) = parse_doid_symbol(); }
    break;

  case 97:
#line 656 "../../../../../git/pers/barvinok/omega/petit/src/petity.y"
    {   
		    P_Sym = parse_symbol(0);
		    (yyval.iv) = P_Sym->symvalue;
		    /* don't allow variables in constant expressions */
		    if( P_Sym->symtype != symconst ){
			fprintf(stderr, "*** not a constant: %s\n", P_Sym->symname );
			parse_die();
		    }
		}
    break;

  case 98:
#line 667 "../../../../../git/pers/barvinok/omega/petit/src/petity.y"
    {   (yyval.iv) = parse_intval(); }
    break;

  case 99:
#line 670 "../../../../../git/pers/barvinok/omega/petit/src/petity.y"
    {   (yyval.iv) = (yyvsp[-2].iv) + (yyvsp[0].iv); }
    break;

  case 100:
#line 673 "../../../../../git/pers/barvinok/omega/petit/src/petity.y"
    {   (yyval.iv) = (yyvsp[-2].iv) - (yyvsp[0].iv); }
    break;

  case 101:
#line 676 "../../../../../git/pers/barvinok/omega/petit/src/petity.y"
    {   (yyval.iv) = - (yyvsp[0].iv); }
    break;

  case 102:
#line 679 "../../../../../git/pers/barvinok/omega/petit/src/petity.y"
    {   (yyval.iv) = (yyvsp[0].iv); }
    break;

  case 103:
#line 682 "../../../../../git/pers/barvinok/omega/petit/src/petity.y"
    {   (yyval.iv) = (yyvsp[-2].iv) * (yyvsp[0].iv); }
    break;

  case 104:
#line 685 "../../../../../git/pers/barvinok/omega/petit/src/petity.y"
    {   (yyval.iv) = (yyvsp[-1].iv); }
    break;

  case 105:
#line 690 "../../../../../git/pers/barvinok/omega/petit/src/petity.y"
    {   (yyval.np) = parse_symbolnode(); }
    break;

  case 106:
#line 695 "../../../../../git/pers/barvinok/omega/petit/src/petity.y"
    {
		    (yyval.np) = (yyvsp[0].np);
		    if((yyvsp[0].np)->nodeop == op_fetch_array) {
		        P_Node = (node*)(yyvsp[0].np)->nodevalue;
			P_Sym = (symtabentry*)P_Node->nodevalue;
			fprintf(stderr,
				"*** array must have %d subscripts: %s\n",
				P_Sym->symdims, P_Sym->symname );
			parse_die();
		    }
		    if((yyvsp[0].np)->nodevalue == 0) {
		        fprintf(stderr,	"*** You use variable (loop index) which is not completely declared ***\n");
			parse_die();
		    }
		}
    break;

  case 107:
#line 712 "../../../../../git/pers/barvinok/omega/petit/src/petity.y"
    {
	            P_Node = (node*)(yyvsp[0].np)->nodevalue;
		    P_Sym = (symtabentry*)P_Node->nodevalue;
		    if( (yyvsp[0].np)->nodeop == op_fetch ){
			fprintf(stderr, "*** not an array or function call: %s\n", P_Sym->symname );
			parse_die();
		    }
		    else if( (yyvsp[0].np)->nodeop == op_index ){
			fprintf(stderr, "*** not an array or function call: %s\n", P_Sym->symname );
			parse_die();
		    }
		    parse_linknode( (yyvsp[0].np) );
		    parse_pushscope( (yyvsp[0].np) );
		}
    break;

  case 108:
#line 727 "../../../../../git/pers/barvinok/omega/petit/src/petity.y"
    {   parse_popscope();
		    parse_unlinknode();

	            P_Node = (node*)(yyvsp[-4].np)->nodevalue;
		    P_Sym = (symtabentry*)P_Node->nodevalue;
		    if((yyvsp[-4].np)->nodeop != op_call) {
		      int count = 0;
		      /* make sure all subscripts are integer expressions */
		      for( P_Node = (yyvsp[-4].np)->nodechild; P_Node != NULL;
			  P_Node = P_Node->nodenext ) {
			count++;
			if( P_Node->exptype != exprint ) {
			  fprintf(stderr, "*** All subscripts must be integer\n" );
			  parse_die();
			}
		      }
		      if(count != (int)P_Sym->symdims) {
			fprintf(stderr, "*** Wrong number of subscripts in %s (load)\n", P_Sym->symname );
			parse_die();
		      }
		    }

		    (yyval.np) = (yyvsp[-4].np);
		}
    break;

  case 109:
#line 753 "../../../../../git/pers/barvinok/omega/petit/src/petity.y"
    {
		    P_Node = make_node( op_constant );
		    P_Node->nodevalue = parse_intval();
		    P_Node->exptype = exprint;
		    (yyval.np) = P_Node;
		}
    break;

  case 110:
#line 761 "../../../../../git/pers/barvinok/omega/petit/src/petity.y"
    {
		    P_Sym = parse_symbol(-1);
		    P_Node = make_node( op_real );
		    P_Node->nodevalue = (unsigned long int)P_Sym;
		    P_Node->exptype = exprreal;
		    (yyval.np) = P_Node;
		}
    break;

  case 111:
#line 770 "../../../../../git/pers/barvinok/omega/petit/src/petity.y"
    {   (yyval.np) = (yyvsp[-1].np); }
    break;

  case 112:
#line 773 "../../../../../git/pers/barvinok/omega/petit/src/petity.y"
    {   (yyval.np) = parse_binaryop((yyvsp[-2].np),op_add,(yyvsp[0].np)); }
    break;

  case 113:
#line 776 "../../../../../git/pers/barvinok/omega/petit/src/petity.y"
    {   (yyval.np) = parse_binaryop((yyvsp[-2].np),op_subtract,(yyvsp[0].np)); }
    break;

  case 114:
#line 779 "../../../../../git/pers/barvinok/omega/petit/src/petity.y"
    {   (yyval.np) = (yyvsp[0].np); }
    break;

  case 115:
#line 782 "../../../../../git/pers/barvinok/omega/petit/src/petity.y"
    {   (yyval.np) = parse_binaryop(make_const(0),op_subtract,(yyvsp[0].np)); }
    break;

  case 116:
#line 785 "../../../../../git/pers/barvinok/omega/petit/src/petity.y"
    {   (yyval.np) = parse_binaryop((yyvsp[-2].np),op_multiply,(yyvsp[0].np)); }
    break;

  case 117:
#line 788 "../../../../../git/pers/barvinok/omega/petit/src/petity.y"
    {   (yyval.np) = parse_binaryop((yyvsp[-2].np),op_divide,(yyvsp[0].np)); }
    break;

  case 118:
#line 791 "../../../../../git/pers/barvinok/omega/petit/src/petity.y"
    {   (yyval.np) = parse_binaryop((yyvsp[-2].np),op_exp,(yyvsp[0].np)); }
    break;

  case 119:
#line 794 "../../../../../git/pers/barvinok/omega/petit/src/petity.y"
    {   (yyval.np) = parse_binaryop((yyvsp[-2].np),op_lt,(yyvsp[0].np)); }
    break;

  case 120:
#line 797 "../../../../../git/pers/barvinok/omega/petit/src/petity.y"
    {   (yyval.np) = parse_binaryop((yyvsp[-2].np),op_le,(yyvsp[0].np)); }
    break;

  case 121:
#line 800 "../../../../../git/pers/barvinok/omega/petit/src/petity.y"
    {   (yyval.np) = parse_binaryop((yyvsp[-2].np),op_eq,(yyvsp[0].np)); }
    break;

  case 122:
#line 803 "../../../../../git/pers/barvinok/omega/petit/src/petity.y"
    {   (yyval.np) = parse_binaryop((yyvsp[-2].np),op_ne,(yyvsp[0].np)); }
    break;

  case 123:
#line 806 "../../../../../git/pers/barvinok/omega/petit/src/petity.y"
    {   (yyval.np) = parse_binaryop((yyvsp[-2].np),op_ge,(yyvsp[0].np)); }
    break;

  case 124:
#line 809 "../../../../../git/pers/barvinok/omega/petit/src/petity.y"
    {   (yyval.np) = parse_binaryop((yyvsp[-2].np),op_gt,(yyvsp[0].np)); }
    break;

  case 125:
#line 812 "../../../../../git/pers/barvinok/omega/petit/src/petity.y"
    {   (yyval.np) = parse_binaryop((yyvsp[-2].np),op_and,(yyvsp[0].np)); }
    break;

  case 126:
#line 815 "../../../../../git/pers/barvinok/omega/petit/src/petity.y"
    {   (yyval.np) = parse_binaryop((yyvsp[-2].np),op_or,(yyvsp[0].np)); }
    break;

  case 127:
#line 818 "../../../../../git/pers/barvinok/omega/petit/src/petity.y"
    {   (yyval.np) = parse_binaryop((yyvsp[0].np),op_not,NULL); }
    break;

  case 128:
#line 821 "../../../../../git/pers/barvinok/omega/petit/src/petity.y"
    {   (yyval.np) = parse_binaryop((yyvsp[-2].np),op_mod,(yyvsp[0].np)); }
    break;

  case 129:
#line 824 "../../../../../git/pers/barvinok/omega/petit/src/petity.y"
    {   (yyval.np) = parse_binaryop((yyvsp[-2].np),op_max,(yyvsp[0].np)); }
    break;

  case 130:
#line 827 "../../../../../git/pers/barvinok/omega/petit/src/petity.y"
    {   (yyval.np) = parse_binaryop((yyvsp[-2].np),op_min,(yyvsp[0].np)); }
    break;

  case 131:
#line 830 "../../../../../git/pers/barvinok/omega/petit/src/petity.y"
    {   (yyval.np) = parse_binaryop(NULL,op_sqrt,(yyvsp[-1].np)); }
    break;

  case 132:
#line 833 "../../../../../git/pers/barvinok/omega/petit/src/petity.y"
    {   (yyval.np) = make_node( op_rand );
                    (yyval.np)->exptype = exprint;
                }
    break;

  case 133:
#line 838 "../../../../../git/pers/barvinok/omega/petit/src/petity.y"
    {   (yyval.np) = parse_binaryop((yyvsp[-3].np),op_floor_divide,(yyvsp[-1].np));
		    (yyval.np)->exptype = exprint;
		}
    break;

  case 134:
#line 843 "../../../../../git/pers/barvinok/omega/petit/src/petity.y"
    {   (yyval.np) = parse_binaryop((yyvsp[-3].np),op_ceiling_divide,(yyvsp[-1].np));
		    (yyval.np)->exptype = exprint;
		}
    break;

  case 135:
#line 848 "../../../../../git/pers/barvinok/omega/petit/src/petity.y"
    {
		    parse_linknode( (yyvsp[0].np) );
		    parse_pushscope( (yyvsp[0].np) );
		}
    break;

  case 136:
#line 853 "../../../../../git/pers/barvinok/omega/petit/src/petity.y"
    {
		    parse_popscope();
		    parse_unlinknode();

		    /* if any of the list's expressions is real, so is this */
		    (yyvsp[-4].np)->exptype = exprint;
		    for( P_Node = (yyvsp[-4].np)->nodechild;
			 P_Node != NULL; P_Node = P_Node->nodenext ) {
			if( P_Node->exptype != exprint ) {
			    (yyvsp[-4].np)->exptype = exprreal;
			}
		    }
		    (yyval.np) = (yyvsp[-4].np);
		}
    break;

  case 137:
#line 871 "../../../../../git/pers/barvinok/omega/petit/src/petity.y"
    { (yyval.np) = make_node( op_max ); }
    break;

  case 138:
#line 874 "../../../../../git/pers/barvinok/omega/petit/src/petity.y"
    { (yyval.np) = make_node( op_min ); }
    break;

  case 139:
#line 879 "../../../../../git/pers/barvinok/omega/petit/src/petity.y"
    {   parse_linknode( (yyvsp[0].np) ); }
    break;

  case 140:
#line 882 "../../../../../git/pers/barvinok/omega/petit/src/petity.y"
    {   parse_linknode( (yyvsp[0].np) ); }
    break;


    }

/* Line 1037 of yacc.c.  */
#line 2493 "petity.cc"

  yyvsp -= yylen;
  yyssp -= yylen;


  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;


  /* Now `shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*------------------------------------.
| yyerrlab -- here on detecting error |
`------------------------------------*/
yyerrlab:
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if YYERROR_VERBOSE
      yyn = yypact[yystate];

      if (YYPACT_NINF < yyn && yyn < YYLAST)
	{
	  YYSIZE_T yysize = 0;
	  int yytype = YYTRANSLATE (yychar);
	  const char* yyprefix;
	  char *yymsg;
	  int yyx;

	  /* Start YYX at -YYN if negative to avoid negative indexes in
	     YYCHECK.  */
	  int yyxbegin = yyn < 0 ? -yyn : 0;

	  /* Stay within bounds of both yycheck and yytname.  */
	  int yychecklim = YYLAST - yyn;
	  int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
	  int yycount = 0;

	  yyprefix = ", expecting ";
	  for (yyx = yyxbegin; yyx < yyxend; ++yyx)
	    if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR)
	      {
		yysize += yystrlen (yyprefix) + yystrlen (yytname [yyx]);
		yycount += 1;
		if (yycount == 5)
		  {
		    yysize = 0;
		    break;
		  }
	      }
	  yysize += (sizeof ("syntax error, unexpected ")
		     + yystrlen (yytname[yytype]));
	  yymsg = (char *) YYSTACK_ALLOC (yysize);
	  if (yymsg != 0)
	    {
	      char *yyp = yystpcpy (yymsg, "syntax error, unexpected ");
	      yyp = yystpcpy (yyp, yytname[yytype]);

	      if (yycount < 5)
		{
		  yyprefix = ", expecting ";
		  for (yyx = yyxbegin; yyx < yyxend; ++yyx)
		    if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR)
		      {
			yyp = yystpcpy (yyp, yyprefix);
			yyp = yystpcpy (yyp, yytname[yyx]);
			yyprefix = " or ";
		      }
		}
	      yyerror (yymsg);
	      YYSTACK_FREE (yymsg);
	    }
	  else
	    yyerror ("syntax error; also virtual memory exhausted");
	}
      else
#endif /* YYERROR_VERBOSE */
	yyerror ("syntax error");
    }



  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse look-ahead token after an
	 error, discard it.  */

      if (yychar <= YYEOF)
        {
          /* If at end of input, pop the error token,
	     then the rest of the stack, then return failure.  */
	  if (yychar == YYEOF)
	     for (;;)
	       {

		 YYPOPSTACK;
		 if (yyssp == yyss)
		   YYABORT;
		 yydestruct ("Error: popping",
                             yystos[*yyssp], yyvsp);
	       }
        }
      else
	{
	  yydestruct ("Error: discarding", yytoken, &yylval);
	  yychar = YYEMPTY;
	}
    }

  /* Else will try to reuse look-ahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:

#ifdef __GNUC__
  /* Pacify GCC when the user code never invokes YYERROR and the label
     yyerrorlab therefore never appears in user code.  */
  if (0)
     goto yyerrorlab;
#endif

yyvsp -= yylen;
  yyssp -= yylen;
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;	/* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (yyn != YYPACT_NINF)
	{
	  yyn += YYTERROR;
	  if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
	    {
	      yyn = yytable[yyn];
	      if (0 < yyn)
		break;
	    }
	}

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
	YYABORT;


      yydestruct ("Error: popping", yystos[yystate], yyvsp);
      YYPOPSTACK;
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  if (yyn == YYFINAL)
    YYACCEPT;

  *++yyvsp = yylval;


  /* Shift the error token. */
  YY_SYMBOL_PRINT ("Shifting", yystos[yyn], yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yydestruct ("Error: discarding lookahead",
              yytoken, &yylval);
  yychar = YYEMPTY;
  yyresult = 1;
  goto yyreturn;

#ifndef yyoverflow
/*----------------------------------------------.
| yyoverflowlab -- parser overflow comes here.  |
`----------------------------------------------*/
yyoverflowlab:
  yyerror ("parser stack overflow");
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
  return yyresult;
}


#line 885 "../../../../../git/pers/barvinok/omega/petit/src/petity.y"

/* program section */

namespace omega {

static 
void CheckEnd() {
  if(ShouldBeEnd) {
    Error("RETURN statement at the middle of a program");
  }
}


/* parse_die */
static void parse_die()
{
    fprintf(stderr, "Ended on line %ld at %s\n", Lines, yytext );
    Exit(1);
}/* parse_die */

/* Utility routine ... get the integer */
static int parse_intval()
{
int val, p;
char ch;

    p = 0;
    val = 0;
    while( (ch=P_INTname[p]) >= '0' && ch <= '9' ){
	val = val * 10 + (ch - '0');
	p = p + 1;
    }
    return val;
}/* parse_intval */

/* Link in a new node at this point. */
static void parse_linknode( node *new_node )
{
    new_node->nodeprev = P_NextPrev;
    new_node->nodeparent = P_NextParent;

    if( P_NextPrev != NULL )
	P_NextPrev->nodenext = new_node;
    if( P_NextParent != NULL && P_NextParent->nodechild == NULL )
	P_NextParent->nodechild = new_node;

    P_NextPrev = new_node;
}/* parse_linknode */

/* unlink node, when it doesn't really belong */
static void parse_unlinknode()
{
node *old;
    old = P_NextPrev;

    P_NextPrev = old->nodeprev;

    if( P_NextParent != NULL && P_NextParent->nodechild == old )
	P_NextParent->nodechild = NULL;
    if( P_NextPrev != NULL )
	P_NextPrev->nodenext = NULL;

    old->nodeprev = NULL;
    old->nodeparent = NULL;
}/* parse_unlinknode */

static void parse_linknodeto( node *old, node *new_node )
{
node *last;
    for(last = old->nodechild;
	last != NULL && last->nodenext != NULL;
	last = last->nodenext ) ;

    new_node->nodeprev = last;
    new_node->nodeparent = old;

    if( last != NULL )
	last->nodenext = new_node;
    if( old->nodechild == NULL )
	old->nodechild = new_node;
}/* parse_linknodeto */

/* Push and Pop scopes */
static void parse_pushscope( node *n )
{
    if( n == 0 ){
	P_NextParent = P_NextPrev;
    } else {
	P_NextParent = n;
    }
    P_NextPrev = NULL;
}/* parse_pushscope */

static void parse_popscope()
{
    P_NextPrev = P_NextParent;
    P_NextParent = P_NextPrev->nodeparent;
}/* parse_popscope */


static exprtype expression_type( node *left, optype op, node *right )
{
exprtype result;

    /* assume the expression's type is integer until proven otherwise */
    result = exprint;

    switch( op ) {
    case op_add:
    case op_subtract:
    case op_multiply:
    case op_divide:
    case op_exp:
    case op_mod:
    case op_max:
    case op_min:
    case op_floor_divide:
    case op_ceiling_divide:
      /* if either expression is real, the result is real */
      if( left != NULL ) {
	  if( left->exptype != exprint && left->exptype != exprrefint ) {
	      result = exprreal;
	  }
      }
      if( right != NULL ) {
	  if( right->exptype != exprint && right->exptype != exprrefint ) {
	      result = exprreal;
	  }
      }
      break;

    case op_lt:
    case op_le:
    case op_eq:
    case op_ne:
    case op_ge:
    case op_gt:
      /* type already set to integer, which these are */
      break;

    case op_sqrt:
      /* type is always real in this case */
      result = exprreal;
      break;

    default:
      /* default is unknown, which had better not happen! */
      result = exprunknown;
      break;
    }

    return( result );
}/* expression_type */

static node *parse_binaryop( node *left, optype op, node *right )
{
node *n;

    n = make_node( op );

    /* get the expression's type */
    n->exptype = expression_type( left, op, right );

    if( left  != NULL ) parse_linknodeto( n, left  );
    if( right != NULL ) parse_linknodeto( n, right );
    return n;
}/* parse_binaryop */

static void parse_forloop(optype op, symtabentry *index,
			node *lower, node *upper, node *inc) {
    node *donode, *doindex;
    int i;

    if(!(P_LoopNest<maxnest))
      ErrAssert("parse_forloop: too deep loop nesting level");
    for(i=0; i<(int)P_LoopNest; i++) {
      if(strcmp(loopsyms[i],index->symname)==0) {
	fprintf(stderr,
		"Loop parameter `%s' is already used in outside loop\n",
		index->symname);
	parse_die();
      }
    }
    loopsyms[P_LoopNest]=index->symname;

    donode = make_node( op );
    parse_linknode( donode );
    ++P_LoopNest;
    donode->nodevalue = P_LoopNest;
    parse_pushscope( donode );

    doindex = make_node( op_dolimit );
    doindex->nodevalue = (unsigned long int)index;
    parse_linknode( doindex );

    parse_linknode( lower );
    parse_linknode( upper );
    if( inc != NULL ) parse_linknode( inc );

    parse_pushscope( doindex );

    index->symtype = symindex;
    index->symdecl = doindex;
    index->exptype = exprrefint; /* we only allow integer index variables */

    /* make sure the lower and upper loop bounds are integer expressions */
    if( lower->exptype != exprint ) {
	fprintf(stderr, "*** lower bound not integer expression\n" );
	parse_die();
    }
    else
    if( upper->exptype != exprint ) {
	fprintf(stderr, "*** upper bound not integer expression\n" );
	parse_die();
    }
    else
    if( inc != NULL ) {
	if( inc->exptype != exprint ) {
	    fprintf(stderr, "*** increment not integer expression\n" );
	    parse_die();
	}
    }
}/* parse_forloop */

static void parse_endforloop()
{
symtabentry *index;

    index = (symtabentry*)P_NextParent->nodevalue;
    index->symtype = symoldindex;
    parse_popscope();
    parse_popscope();
    --P_LoopNest;
}/* parse_endforloop */

nametabentry *parse_findsym()
{
nametabentry *f;

    for( f = NameHead; f != NULL; f = f->namenext ){
	if( strcmp( f->namest.symname, P_IDname ) == 0 &&
	    f->namest.symtype != symoldindex ){
	     return f;
	}
    }
    return NULL;
}/* parse_findsym */

symtabentry *add_symbol(const char *name, int new_int,
			symboltype symtype, exprtype exptype,
			nametabentry *onam)
{
  nametabentry *nam;

#if 0  
  fprintf(stderr, "At line %ld, adding symbol %s to name table\n", Lines, name);
  for (nam = NameHead; nam; nam = nam->namenext)
  {
      fprintf(stderr, "   %s\n", nam->namest.symname);
  }
#endif

  nam = new nametabentry;
  if (!nam) out_of_memory();
  nam->namenext = NameHead;
  NameHead = nam;
  nam->namest.symtype = symtype;
  nam->namest.symdims = 0;
  nam->namest.symdecl = NULL;
  nam->namest.def_node = NULL;
  nam->namest.symname = (char*)calloc( strlen( name )+1, 1 );
  if (!nam->namest.symname) out_of_memory();
  strcpy( nam->namest.symname, name );
  nam->namest.nte = nam;
  nam->namest.original = NULL;
  nam->namest.exptype = exptype;
  nam->namest.symoffset = 0;	  /* set later if needs memory */
  nam->namest.symtag = UNTAGGED;
  nam->namest.omega_vars = 0;
  if(new_int==0 && onam==NULL) {
    node *n = make_node( op_declare );
    n->nodevalue = (unsigned long int)(&nam->namest);
    nam->namest.symdecl = n;
    nam->namest.symclass = CLFORMAL;
    PlaceNodeBefore(n,Entry->nodechild);
  }
  return &(nam->namest);
}

/*
 * Find/create symbol table entry.
 * new_int : 0 - name should already exist or you'll get error message,
 *       1 - name should not exist or get error message,
 *       2 - create new name even if the entry with this name exists already
 */
symtabentry *parse_symbol(int new_int) {
  nametabentry *nam = parse_findsym();
  nametabentry *onam = nam;
  
  if(NoNewOldCheck) {
    if(nam)
      return &(nam->namest);
  } else {
    if( new_int == 0 ){
      if( nam == NULL ){
	fprintf(stderr, "*** `%s' is undeclared variable ***\n", P_IDname);
	parse_die();
      }
      return &(nam->namest);
    }
    if( new_int == 1 ) {
      if( nam != NULL ){
	fprintf(stderr, "Warning: variable `%s' declared twice, 2nd declaration on line %ld\n", P_IDname, Lines);
	return &(nam->namest);
      }
    }
  }

  return add_symbol(P_IDname, new_int, syminteger, exprrefint, onam);
       /* we'll set the type later */
}/* parse_symbol */

/*
 * create symbol table entry for loop, and for loop step count
 * (the latter is needed so that we can have a var_id for the omega test)
 */

static symtabentry *parse_doid_symbol()
{
    symtabentry *id, *stepsym;
    char loop_step_name[256];
    sprintf(loop_step_name, "<%s-trip>", P_IDname);
    stepsym = add_symbol(loop_step_name, 1, symloopstep, exprrefint, 0);
    id = parse_symbol(2);
    assert(&(id->nte->namenext->namest) == stepsym);
    return id;
}
							      
/*
 * Make node referencing already existing variable
 */
node *parse_symbolnode()
{
node *nod;
symtabentry *sym;

    sym = parse_symbol( 0 );

    if( sym->symtype == symindex ){
	nod = make_node( op_index );
	nod->nodevalue = (unsigned long int)sym->symdecl;
	nod->exptype = exprint;	       /* all index expressions are integer */
    } else if( sym->symtype == symconst ) {
	nod = make_node( op_constant );
	nod->nodevalue = (unsigned long int)sym->symvalue;
	nod->exptype = exprint;	       /* all constants are integers */
    } else if( sym->symdims == 0 ) {   /* determine type of scalar var */
	nod = make_node( op_fetch );
	nod->nodevalue = (unsigned long int)sym->symdecl;
	if( sym->exptype == exprrefint )
	    nod->exptype = exprint;
	else if( sym->exptype == exprrefreal )
	    nod->exptype = exprreal;
	else
	    nod->exptype = exprunknown;
    } else if(sym->symdims == DIMSFUN) {   /* builtin function */
	nod = make_node( op_call );
	nod->nodevalue = (unsigned long int)sym->symdecl;
	if( sym->exptype == exprintfun )
	    nod->exptype = exprint;
	else if( sym->exptype == exprrealfun )
	    nod->exptype = exprreal;
	else
	    nod->exptype = exprunknown;
    } else if( sym->symdims > 0 ) {
	nod = make_node( op_fetch_array );
	nod->nodevalue = (unsigned long int)sym->symdecl;
	if( sym->exptype == exprintarray )
	    nod->exptype = exprint;     /* if int array, then just int */
	else
	if( sym->exptype == exprrealarray )
	    nod->exptype = exprreal;    /* if real array, then just real */
	else
	    nod->exptype = exprunknown;
    } else {
	fprintf(stderr, "unknown symbol %s\n", sym->symname );
	parse_die();
	nod = 0;  // make g++ calm down about initialization
    }
    return nod;
}/* parse_symbolnode */

static void parse_stmt_index( node *n )
{
node *index;

    if( n == NULL ) return;
    parse_stmt_index( n->nodeparent );
    if( n->nodeop == op_dolimit ){
	index = make_node( op_index );
	index->nodevalue = (unsigned long int)n;
	parse_linknode( index );
    }
}/* parse_stmt_index */

static void parse_check_stmt_number()
/* Put an op_stmt_number here. */
{
node *stmt_number;

    if( P_NextParent != NULL && P_NextParent->nodeop == op_dolimit ){
	++P_StmtNumber;
	stmt_number = make_node( op_stmt_number );
	stmt_number->nodevalue = P_StmtNumber;
	parse_linknode( stmt_number );
	parse_pushscope( stmt_number );
	parse_stmt_index( stmt_number->nodeparent );
	parse_popscope();
    }
}/* parse_check_stmt_number */

/* Initialize everything. */
static void parse_init()
{
    Lines = 1;
    P_Lines = 1;
    P_LoopNest = 0;
    P_StmtNumber = 0;

    /* Initialize entry point. */
    Entry = make_node( op_entry );

    /* Initialize node links. */
    P_NextPrev = NULL;
    P_NextParent = Entry;

    NameHead = NULL;
}/* parse_init */

void yyerror( char *s)
{
    fprintf(stderr, "%s\n", s );
    parse_die();
}/* yyerror */

} // end of namespace omega

