#include <iostream>

#include "yaml.h"
#include "pdg.h"

using namespace std;
using namespace pdg;

int main(int argc, char * argv[])
{
    PDG *pdg;
    pdg = yaml::Load<PDG>(stdin);

    printf("digraph dummy {\n");
    for (int i = 0; i < pdg->nodes.size(); ++i) {
	pdg::node *node = pdg->nodes[i];
	if (node->statement->top_function)
	    printf("ND_%d [label = \"%s\"];\n", 
		    node->nr, node->statement->top_function->name->s.c_str());
	else
	    printf("ND_%d;\n", node->nr);
    }
    for (int i = 0; i < pdg->dependences.size(); ++i) {
	pdg::dependence *dep = pdg->dependences[i];
	if (dep->type == pdg::dependence::uninitialized)
	    continue;
	if (dep->type == pdg::dependence::pn_part)
	    continue;
	pdg::node* from = dep->from;
	pdg::node* to = dep->to;
	printf("ND_%d -> ND_%d [label = \"%s: %s\"%s];\n", from->nr, to->nr,
		dep->array->name->s.c_str(),
		dep->size ? dep->size->s->c_str() : "?",
		dep->type == pdg::dependence::pn_union ? " color=\"blue\"" :
		dep->type == pdg::dependence::pn_hold ? " color=\"cyan\"" :
		dep->type == pdg::dependence::pn_shift ? " color=\"magenta\"" :
		dep->reordering ? 
		    (dep->multiplicity ? " color=\"yellow\"": " color=\"green\"") : 
		    (dep->multiplicity ? " color=\"red\"": ""));
    }
    printf("}\n");

    pdg->free();
    delete pdg;

    return 0;
}
